unit JkfEditorForm;

{  -------------------------------------------------
   jkfStream 1.0

   Copyright (c) 2001 Kim Friis, Friisware.com
   kim@friisware.com

   This software is Freeware and without any
   warranty what so ever. Don't blame me if it
   crashes your computer, burns down your house or
   steals all your friends :-). (You get the picture)
   Please use at own risk.
   ------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jkfStreams, ComCtrls, ExtCtrls, StdCtrls;

type
  TJKFPakEditor = class(TForm)
    Pak: TJkfStoredPack;
    Panel1: TPanel;
    Panel2: TPanel;
    BOk: TButton;
    BCancel: TButton;
    BAdd: TButton;
    BRemove: TButton;
    BExtract: TButton;
    BLoad: TButton;
    BSave: TButton;
    OD: TOpenDialog;
    ODZ: TOpenDialog;
    SDZ: TSaveDialog;
    SD: TSaveDialog;
    Panel3: TPanel;
    FileView: TListView;
    cbPacktype: TComboBox;
    Label1: TLabel;
    procedure BAddClick(Sender: TObject);
    procedure BRemoveClick(Sender: TObject);
    procedure BLoadClick(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure BExtractClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure Refresh;
    procedure EndProgram(Sender: TObject);
  public
    { Public declarations }
  end;

var
  JKFPakEditor: TJKFPakEditor;

implementation

uses
  ZLibClass;

{$R *.DFM}

{ TJKFPakEditor }

procedure TJKFPakEditor.Refresh;
var
  SL:TJkfFileList;
  I:Integer;
  LI:TListItem;
  S:String;
begin
  FileView.Items.Clear;
  SL := TJkfFileList.Create;
  try
    Pak.View(SL);
    cbPacktype.ItemIndex := Ord(Pak.PackType);
    for I := 0 to SL.Count - 1 do begin
      LI := FileView.Items.Add;
      LI.Caption := SL[I];
      S := IntToStr(SL.SizesUnpacked[I]);
      LI.SubItems.Add(S);
      S := IntToStr(SL.SizesPacked[I]);
      LI.SubItems.Add(S);
    end;
  finally
    SL.Free;
  end;
end;

procedure TJKFPakEditor.BAddClick(Sender: TObject);
begin
  if OD.Execute then begin
    case cbPacktype.ItemIndex of
      0:Pak.PackType := zpNone;
      1:Pak.PackType := zpFastest;
      2:Pak.PackType := zpMedium;
      3:Pak.PackType := zpMaximum;
    end;
    Pak.AddFile(OD.Filename);
    Refresh;
  end;
end;

procedure TJKFPakEditor.BRemoveClick(Sender: TObject);
var
  S:String;
begin
  if FileView.SelCount > 0 then begin
    S := FileView.Selected.Caption;
    Pak.RemoveFile(S);
    Refresh;
  end;
end;

procedure TJKFPakEditor.BLoadClick(Sender: TObject);
begin
  if ODZ.Execute then begin
    Pak.LoadFromFile(ODZ.Filename);
    Refresh;
  end;
end;

procedure TJKFPakEditor.BSaveClick(Sender: TObject);
begin
  if SDZ.Execute then begin
    Pak.SaveToFile(SDZ.Filename);
    Refresh;
  end;
end;

procedure TJKFPakEditor.BExtractClick(Sender: TObject);
var
  S:String;
begin
  if FileView.SelCount > 0 then begin
    S := FileView.Selected.Caption;
    SD.FileName := S;
    if SD.Execute then begin
      Pak.ExtractFileToFile(S,SD.Filename);
    end;
  end;
end;

procedure TJKFPakEditor.FormShow(Sender: TObject);
begin
  if Pos('Delphi',Application.Title) < 1 then begin
    BCancel.Visible := False;
    BOk.OnClick := EndProgram;
    BOk.Caption := 'Close';
  end;
  Refresh;
end;

procedure TJKFPakEditor.EndProgram(Sender: TObject);
begin
  Close;
end;

end.
